#ifndef CYCLES_H_
#define CYCLES_H_

enum statuses {
        PARTING,
        JOINING
};

struct cycle_channel_t {
        char channel[MAXCHANLEN];
        int delay;
        enum statuses status;
};

typedef struct cycle_channel_t cycle_chan;

typedef long timestamp_t;
typedef void (*TIMEOUT_FUNC)(gpointer);

void initialize_cycle_checks(void);

int cycle_chan_add(const char *chan, int delay, gboolean dbadd);
int cycle_chan_del(char *chan);
int cycle_chan_schedule_check(cycle_chan *cc);

void cycle_list_to(irc_user *u, char *s);

int timeout_add(unsigned long secs, TIMEOUT_FUNC tof, gpointer data);
void timeout_run(void);
void timeout_clean(void);

#endif
