/* Copyright (C) 2003, 2004 IRCtoo Network, Pasi Hirvonen <psh@iki.fi>
 *
 * Parts written by FJ (David). Based on the original work by Pasi Hirvonen
 * and Matthew Stephenson. Various others have contributed ideas and testing.*/

/* $Id: mainloop.c 107 2004-05-20 13:33:00Z pasi $ */

#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <time.h>
#include <stdarg.h>
#include <glib.h>

#include "structs.h"
#include "mainloop.h"
#include "server.h"
#include "spamserv.h"
#include "log.h"

extern struct status_t status;
extern struct conf_t conf;

void s_main_loop(void) {
	int err;

	while (status.quitting != 1) { /* forever */
		do {
			if (s_connect_to_server() < 0)
				sleep(10);
		} while (status.connected == 0);
		/* clear our schedular */
		g_timer_start(status.scheduler);
		err = s_receive_loop();
		if (err < 0)
			sleep(10);
		g_timer_stop(status.scheduler);
	}
	s_log(LOG_INFO, "Quitting!");
}
