/* Copyright (C) 2003, 2004 IRCtoo Network, Pasi Hirvonen <psh@iki.fi> */

#ifndef _SERVER_H_
#define _SERVER_H_

#include "structs.h"
#include "irc.h"

/* The mail I/O loop, everything starts from here after
 * getting connected */
int s_receive_loop(void);

/* Obvious */
int s_connect_to_server(void);

/* This is called every time server connection is closed,
 * does the necessary cleanup. */
void s_close_connection(const gchar *);

/* Send text to server. */
int send_raw(char *, ...);

/* Called after we are synchronized to network data, i.e.
 * after third PING/PONG. */
void s_do_synch(void);
#endif /* _SERVER_H_ */
