/* Copyright (C) 2003, 2004 IRCtoo Network, Pasi Hirvonen <psh@iki.fi> */

#ifndef _UTIL_H_
#define _UTIL_H_

/* strip all control information from buffer pointed by
 * the argument. modifies string in-place. rips colours,
 * bold, underline and reverse. */
char *strip_all(char *);

/* generate a pseudoclient hostmask */
char *s_print_random_bothost(void);

/* note that this uses static buffer */
char *s_print_usermask(irc_user *, gboolean);

/* timestamp -> human readable form */
char *s_timestamp_to_human(time_t unixtime);

/* validate a channel name (characters and length)  */
int isvalid_chan(const char *);

/* Check whether given nick is available for user or not.
 * This is to prevent collisions 
 * 0 = not available
 * 1 = available */
int s_is_nick_free(char *nick);

/* return a new nickname from the spamserv bot list */
char *getnick(void);

/* generic removal function for GSList information, suitable
 * for several GSLists used by SpamServ. */
void s_free_slist_generic(GSList **list);

/* send out a helpfile from help/ dir. */
int s_send_helpfile(irc_user *to, const char *file);

/* print out error */
char *s_print_err(int errnum);

void s_gslist_foreach(GSList *, GFunc, gpointer);

#endif
